.386p
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc


Extrn SetUnhandledExceptionFilter : PROC

Interrupt      equ 5                            ;cislo prerusenia, cisla 1 alebo 3 stazia debugovanie

.DATA

sprava1        db "Detekcia pomocou Int 2Fh_ GET DEVICE API ENTRY POINT pre VXD SICE",0
sprava2        db "Debuger nenasiel",0
sprava3        db "Debuger najdeny",0
odlozESP       dd 0                             ;sem uklada register ESP
predchadzajuca dd 0                             ;sem uklada adresu predchadzajucej obsluhy SEH
znacka         db 0                             ;sem nastavi hodnotu 1, ak je Soft-Ice aktivny v pamati
skuska         db 'skuska',24h


.CODE
Start:

;----------------------------------------------------------------------------
;NASTAVI SEH PRE PRIPAD CHYBY
;----------------------------------------------------------------------------
                mov  [odlozESP],esp
                push offset chyba
                call SetUnhandledExceptionFilter
                mov  [predchadzajuca], eax
;----------------------------------------------------------------------------

                push edx
                sidt [esp-2]                    ;nacita IDT do stacku
                pop  edx

                add  edx,(Interrupt*8)+4        ;nacita vektor nami pozadovaneho prerusenia (INT 5h)


                mov  ebx,[edx]
                mov  bx,word ptr [edx-4]        ;nacita adresu starej obsluhy nami pozadovaneho prerusenia (INT 5h)

                lea  edi,InterruptHandler
                mov  [edx-4],di
                ror  edi,16                     ;nastavi novu obsluhu prerusenia (INT 5h)
                mov  [edx+2],di

                push ds                         ;ulozi registre koli bezpecnosti
                push es


                int  Interrupt                  ;skok do Ring0 (nami definovana nova obsluha INT 5h)

                pop  es                         ;obnovi registre
                pop  ds

                push ds                         ;ulozi registre koli bezpecnosti
                push es


                mov  ah,43h
                int  68h                        ;vola INT 68h a funkciu 43h (bude zavolana nasa nova obsluha INT 68h)

                stc                             ;nastavi znacku, ze moze zrusit nasu obsluhu INT 68h

                int  Interrupt                  ;skok do Ring0 (nasa obsluha INT 5h)

                pop  es                         ;obnovi registre
                pop  ds

                mov  [edx-4],bx                 ;nastavi povodnu obsluhu prerusenia INT 5h
                ror  ebx,16
                mov  [edx+2],bx


;----------------------------------------------------------------------------
;NASTAVI PREDCHADZAJUCU OBSLUHU SEH
;----------------------------------------------------------------------------
                push dword ptr [predchadzajuca]
                call SetUnhandledExceptionFilter
;----------------------------------------------------------------------------

                cmp  byte ptr znacka,1          ;testuje, ci je nastavena znacka, ze Soft-Ice je aktivny v pamati
                jz   skok                       ;ak ano skoci


continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                call ExitProcess, -1


chyba:                                          ;nova obsluha SEH pre pripad chyby

                mov  esp, [odlozESP]
                push offset continiue
                ret

;----------------------------------------------------------------------------
;NASA NOVA OBSLUHA INT 5h (bezi v Ring0)
;----------------------------------------------------------------------------
InterruptHandler:

                pushad                          ;ulozi registre

                jc   odinstaluj                 ;testuje nasu znacku, ak je nastavena skoci odinstalovat nasu obsluhu INT 68h

                mov  eax, 68h                   ;cislo prerusenia, na ktore nastavi nasu novu obsluhu
                mov  esi, offset HookInt68      ;adresa nasej novej obsluhy
                db   0cdh,20h                   ;vola VxD volanie Hook_V86_Int_Chain
                dd   000010041H
;      VMMCall  Hook_V86_Int_Chain

                mov  eax, 68h                   ;cislo prerusenia, na ktore nastavi nasu novu obsluhu
                mov  esi, OFFSET HookInt68      ;adresa nasej novej obsluhy
                db   0cdh,20h                   ;vola VxD volanie Hook_PM_Fault
                dd   000010080H
;      VMMCall  Hook_PM_Fault

                popad                           ;obnovi registre

                iretd                           ;skok spat do RING3

odinstaluj:                                     ;sem skace, ak ma odinstalovat nasu obsluhu INT 68h

                mov  eax, 68h                   ;cislo prerusenia, na ktorom je nastavena nasa nova obsluha
                mov  esi, OFFSET HookInt68      ;adresa nasej novej obsluhy
                db   0cdh,20h                   ;vola VxD volanie UnHook_V86_Int_Chain
                dd   000010118H
;      VMMCall  UnHook_V86_Int_Chain

                mov  eax, 68h                   ;cislo prerusenia, na ktorom je nastavena nasa nova obsluha
                mov  esi, OFFSET HookInt68      ;adresa nasej novej obsluhy
                db   0cdh,20h                   ;vola VxD volanie UnHook_PM_Fault
                dd   00001011AH
;      VMMCall  UnHook_PM_Fault

                popad                           ;obnovi registre

                iretd                           ;skok spat do RING3

;-----------------------------------------------------------------------------
;NASA NOVA OBSLUHA INT 68h
;-----------------------------------------------------------------------------
HookInt68:


                pushfd                          ;
                pushad                          ;ulozi registre

                xor  di, di                     ;
                mov  es, di                     ;nuluje es:di
                mov  bx, 202h                   ;VxD ID pre SICE VXD
                mov  ax, 1684h                  ;cislo funkcie GET DEVICE API ENTRY POINT
                int  2Fh                        ;vola GET DEVICE API ENTRY POINT


;                mov  ax, es                     ;hodnotu z es da do ax
;                add  ax, di                     ;k ax pripocita di
                mov  ax,di
                test ax,ax                      ;testuje, ci je ax=0
                jz  short neni                  ;ak ano skoci, pretoze Soft-Ice nie je aktivny v pamati

                mov  byte ptr znacka,1          ;nastavi znacku, ze Soft-Ice je aktivny

neni:
                popad                           ;
                popfd                           ;obnovi registre
                ret                             ;skok spat z obsluhy


ends
end Start
