
.386p
.MODEL FLAT,STDCALL
locals
jumps
UNICODE=0
include w32.inc


Extrn SetUnhandledExceptionFilter : PROC

Interrupt      equ 5                            ;cislo prerusenia, cisla 1 alebo 3 stazia debugovanie

.DATA

sprava1        db "Detekcia debug breakpointov ",0
sprava2        db "Debug breakpoint nenasiel",0
sprava3        db "Debug breakpoint najdeny",0
odlozESP       dd 0                             ;sem uklada register ESP
predchadzajuca dd 0                             ;sem uklada adresu predchadzajucej obsluhy SEH



.CODE
Start:

;----------------------------------------------------------------------------
;NASTAVI SEH PRE PRIPAD CHYBY
;----------------------------------------------------------------------------
                mov  [odlozESP],esp
                push offset chyba
                call SetUnhandledExceptionFilter
                mov  [predchadzajuca], eax
;----------------------------------------------------------------------------

                push edx
                sidt [esp-2]                    ;nacita IDT do stacku
                pop  edx

                add  edx,(Interrupt*8)+4        ;nacita vektor nami pozadovaneho prerusenia


                mov  ebx,[edx]
                mov  bx,word ptr [edx-4]        ;nacita adresu starej obsluhy nami pozadovaneho prerusenia

                lea  edi,InterruptHandler
                mov  [edx-4],di
                ror  edi,16                     ;nastavi novu obsluhu prerusenia
                mov  [edx+2],di

                push ds                         ;ulozi registre koli bezpecnosti
                push es


                int  Interrupt                  ;skoci do Ring0 (nami definovana nova obsluha INT 5h)

                pop  es                         ;obnovi registre
                pop  ds


                mov  [edx-4],bx                 ;nastavi povodnu obsluhu prerusenia (INT 5h)
                ror  ebx,16
                mov  [edx+2],bx


                push eax                        ;ulozi navratovu hodnotu

;----------------------------------------------------------------------------
;NASTAVI PREDCHADZAJUCU OBSLUHU SEH
;----------------------------------------------------------------------------
                push dword ptr [predchadzajuca]
                call SetUnhandledExceptionFilter
;----------------------------------------------------------------------------

                pop  eax                     ;obnovi navratovu hodnotu

                test eax,eax                 ;testuje, ci je eax=0
                jnz  skok                    ;ak nie, nasiel debug breakpoint a skoci

continiue:
                call MessageBoxA,0, offset sprava2, offset sprava1,0
                call ExitProcess, -1

skok:

                call MessageBoxA,0, offset sprava3, offset sprava1,0
                call ExitProcess, -1



chyba:                                          ;nova obsluha SEH pre pripad chyby

                mov  esp, [odlozESP]
                push offset continiue
                ret


;----------------------------------------------------------------------------
;NASA NOVA OBSLUHA INT 5h (bezi v Ring0)
;----------------------------------------------------------------------------
InterruptHandler:

                mov  eax,dr0                   ;nacita hodnotu z debug registra DR0
                test ax,ax                     ;testuje, ci bol nastaveny breakpoint
                jnz  Debug_Breakpoint          ;ak ano skok

                mov  eax,dr1                   ;nacita hodnotu z debug registra DR1
                test ax,ax                     ;testuje, ci bol nastaveny breakpoint
                jnz  Debug_Breakpoint          ;ak ano skok

                mov  eax,dr2                   ;nacita hodnotu z debug registra DR2
                test ax,ax                     ;testuje, ci bol nastaveny breakpoint
                jnz  Debug_Breakpoint          ;ak ano skok

                mov  eax,dr3                   ;nacita hodnotu z debug registra DR3
                test ax,ax                     ;testuje, ci bol nastaveny breakpoint
                jnz  Debug_Breakpoint          ;ak ano skok

                iretd                          ;ak nebol nastaveny breakpoint, vrati v registri eax hodnotu 0


Debug_Breakpoint:
                mov  eax,1                     ;nastavi do registra eax hodnotu 1 na znak, ze debug breakpointy su aktivne
                iretd                          ;skok spat do RING3


ends
end Start
