#include <windows.h>
#include <stdio.h>
#include "Resource.h"

/*-----------------------------------------------------------*/

int APIENTRY MyDlgProc(HWND,WORD,LONG,LONG);
BOOL TestSerial(HWND);

/*-----------------------------------------------------------*/

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,int nCmdShow) {

  UNREFERENCED_PARAMETER(nCmdShow);
  UNREFERENCED_PARAMETER(lpCmdLine);
  UNREFERENCED_PARAMETER(hPrevInstance);

  return(DialogBox((HANDLE)hInstance,(LPCSTR)"Serial2",NULL,(DLGPROC)MyDlgProc));
}

/*-----------------------------------------------------------*/

int APIENTRY MyDlgProc(HWND hDlg, WORD wMsg, LONG wParam, LONG lParam) {

  UNREFERENCED_PARAMETER(lParam);

  switch(wMsg) {
    case WM_INITDIALOG:
      SendDlgItemMessage(hDlg,MY_EDIT1,EM_SETLIMITTEXT,(WPARAM)100,0);
      SendDlgItemMessage(hDlg,MY_EDIT2,EM_SETLIMITTEXT,(WPARAM)100,0);
      break;

    case WM_SYSCOMMAND:
      if(wParam == SC_CLOSE)  {
        EndDialog(hDlg,TRUE);
        return (TRUE);
      }
      break;

    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case MY_BUTTON_REG:
          if(HIWORD(wParam)==BN_CLICKED) {
            if(TestSerial(hDlg))
              MessageBox(hDlg,"Sriov slo je v podku. Dkujeme za registraci.","Registrace",MB_ICONINFORMATION);
            else
              MessageBox(hDlg,"patn sriov slo, zkuste to znovu","Registrace",MB_ICONSTOP);
          }
          break;

        case MY_BUTTON_CAN:
          if(HIWORD(wParam)==BN_CLICKED) 
            PostQuitMessage(0);
          break;
      }
  }

  return(FALSE);
}

/*-----------------------------------------------------------*/

BOOL TestSerial(HWND hDlg) {
char* Serial=(char*)malloc(100*sizeof(char));
char* Buffer=(char*)malloc(10*sizeof(char));
char* Jmeno=(char*)malloc(100*sizeof(char));

BOOL RetValue = FALSE;

DWORD Soucet = 0x12345678;
DWORD Temp;

unsigned DelkaSerial;
unsigned DelkaJmeno;
unsigned i;

  if((DelkaJmeno = GetDlgItemText(hDlg,MY_EDIT1,Jmeno,100)) >= 4 &&
     (DelkaSerial = GetDlgItemText(hDlg,MY_EDIT2,Serial,100)) == 13) {
    do {
      if(strncmp(Serial,"MEGA-",5) != 0)
        break;

      for(i=0;i<DelkaJmeno;i++) {
        Temp = (Soucet ^ Jmeno[i]) & 0x000000FF;
        Soucet = (Soucet >> 8) ^ (Temp << 24);
      }

      sprintf(Buffer,"%08X\0",Soucet);

      if(strcmp(Buffer,Serial+5) != 0)
        break;

      RetValue = TRUE;
    } while(FALSE);
  }

  free(Serial);
  free(Buffer);
  free(Jmeno);

  return RetValue;
}

// Sprvne registran daje s:
// Testovac jmno
// MEGA-230B4F68

/*-----------------------------------------------------------*/
